> ## Documentation Index
> Fetch the complete documentation index at: https://docs.blnkfinance.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Backdated Transactions

> Learn how to log past transactions in your ledger

export const CtaCallout = props => {
  const {title, buttonLabel, href, trackingEvent, buttonTarget, rel = "noopener noreferrer", children} = props;
  const handleCtaClick = () => {
    if (typeof window === "undefined" || !trackingEvent) {
      return;
    }
    try {
      window.dispatchEvent(new CustomEvent("blnk:docs-cta", {
        detail: {
          name: trackingEvent,
          href
        }
      }));
    } catch {}
    try {
      window.posthog?.capture?.(trackingEvent, {
        href
      });
    } catch {}
    const gaPayload = {
      cta_href: href
    };
    try {
      window.gtag?.("event", trackingEvent, gaPayload);
    } catch {}
    try {
      window.dataLayer = window.dataLayer || [];
      window.dataLayer.push({
        event: trackingEvent,
        ...gaPayload
      });
    } catch {}
  };
  const isExternal = typeof href === "string" && (/^https?:\/\//i).test(href);
  const target = buttonTarget ?? (isExternal ? "_blank" : undefined);
  const linkRel = isExternal ? rel : undefined;
  return <section className="cta-callout not-prose relative my-8 w-full min-w-0 overflow-hidden rounded-xl border border-zinc-200 p-5 dark:border-white/10">
      <div className="cta-callout-noise" aria-hidden="true" />
      <div className="cta-callout-layout">
        {title ? <div className="cta-callout-title-row">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 28 28" width="14" height="14" className="cta-callout-icon shrink-0 text-zinc-800 dark:text-zinc-200" aria-hidden="true">
              <g fill="none" fillRule="nonzero">
                <path d="M28 0v28H0V0h28ZM14.691833333333335 27.134333333333334l-0.012833333333333334 0.0023333333333333335 -0.08283333333333333 0.04083333333333334 -0.023333333333333334 0.004666666666666667 -0.016333333333333335 -0.004666666666666667 -0.08283333333333333 -0.04083333333333334c-0.011666666666666667 -0.004666666666666667 -0.022166666666666668 -0.0011666666666666668 -0.028000000000000004 0.005833333333333334l-0.004666666666666667 0.011666666666666667 -0.019833333333333335 0.49933333333333335 0.005833333333333334 0.023333333333333334 0.011666666666666667 0.015166666666666667 0.12133333333333333 0.08633333333333333 0.0175 0.004666666666666667 0.014000000000000002 -0.004666666666666667 0.12133333333333333 -0.08633333333333333 0.014000000000000002 -0.018666666666666668 0.004666666666666667 -0.019833333333333335 -0.019833333333333335 -0.4981666666666667c-0.0023333333333333335 -0.011666666666666667 -0.0105 -0.019833333333333335 -0.019833333333333335 -0.021Zm0.3091666666666667 -0.13183333333333336 -0.015166666666666667 0.0023333333333333335 -0.21583333333333335 0.1085 -0.011666666666666667 0.011666666666666667 -0.0035000000000000005 0.012833333333333334 0.021 0.5016666666666667 0.005833333333333334 0.014000000000000002 0.009333333333333334 0.008166666666666668 0.23450000000000004 0.1085c0.014000000000000002 0.004666666666666667 0.026833333333333334 0 0.03383333333333334 -0.009333333333333334l0.004666666666666667 -0.016333333333333335 -0.03966666666666667 -0.7163333333333334c-0.0035000000000000005 -0.014000000000000002 -0.011666666666666667 -0.023333333333333334 -0.023333333333333334 -0.025666666666666667Zm-0.8341666666666667 0.0023333333333333335a0.026833333333333334 0.026833333333334334 0 0 0 -0.0315 0.007000000000000001l-0.007000000000000001 0.016333333333333335 -0.03966666666666667 0.7163333333333334c0 0.014000000000000002 0.008166666666666668 0.023333333333333334 0.019833333333333335 0.028000000000000004l0.0175 -0.0023333333333333335 0.23450000000000004 -0.1085 0.011666666666666667 -0.009333333333333334 0.004666666666666667 -0.012833333333333334 0.019833333333333335 -0.5016666666666667 -0.0035000000000000005 -0.014000000000000002 -0.011666666666666667 -0.011666666666666667 -0.21466666666666667 -0.10733333333333334Z" strokeWidth="1.1667" />
                <path fill="currentColor" d="M14 2.916666666666667A1.75 1.75 0 0 1 15.750000000000002 4.666666666666667v6.302333333333334L21.207666666666668 7.816666666666667a1.75 1.75 0 0 1 1.75 3.031L17.5 14l5.457666666666667 3.151166666666667a1.75 1.75 0 0 1 -1.75 3.031l-5.457666666666667 -3.1500000000000004V23.333333333333336a1.75 1.75 0 0 1 -3.5 0v-6.302333333333334L6.792333333333334 20.183333333333337a1.75 1.75 0 1 1 -1.75 -3.031L10.5 14 5.042333333333334 10.848833333333333a1.75 1.75 0 0 1 1.75 -3.031l5.457666666666667 3.1500000000000004V4.666666666666667A1.75 1.75 0 0 1 14 2.916666666666667Z" strokeWidth="1.1667" />
              </g>
            </svg>
            <p className="cta-callout-title min-w-0 font-semibold text-zinc-800 dark:text-zinc-200">
              {title}
            </p>
          </div> : null}
        <div className={`cta-callout-body text-sm leading-normal text-zinc-800 dark:text-zinc-200${title ? " cta-callout-body--indented" : ""}`}>
          {children}
        </div>
        <a href={href} target={target} rel={linkRel} onClick={handleCtaClick} data-docs-cta={trackingEvent || undefined} className="cta-callout-button inline-flex items-center justify-center gap-1 rounded-full bg-white px-3 py-1.5 text-sm font-semibold transition hover:bg-zinc-100 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-white/50 dark:bg-white dark:hover:bg-zinc-200">
          {buttonLabel}
          <span className="cta-callout-button-arrow" aria-hidden="true">
            →
          </span>
        </a>
      </div>
    </section>;
};

<Info>Available in version 0.9.0 and later.</Info>

The `effective_date` feature is a critical functionality in financial systems that allows recording transactions with a financial date different from their system entry date.

This capability ensures seamless migration, accurate financial reporting, reconciliation, and historical balance calculations.

***

## Effective date vs created date

When `effective_date` isn't specified, it defaults to the same value as `created_at`.

* `created_at`: Timestamp of when the transaction was recorded in the system.
* `effective_date`: The actual financial date when the transaction occurred

***

## Create transaction with effective date

Call the [Record Transaction](/reference/create-transaction) endpoint:

<CodeGroup>
  ```bash cURL wrap theme={"system"}
  curl -X POST "http://YOUR_BLNK_INSTANCE_URL/transactions" \
    -H "X-blnk-key: <api-key>" \
    -H "Content-Type: application/json" \
    -d '{
      "precise_amount": 35890,
      "precision": 100,
      "reference": "unique_reference_1",
      "description": "Backdated transaction",
      "currency": "NGN",
      "source": "@source_account",
      "destination": "@destination_account",
      "effective_date": "2025-02-15T10:30:00Z"
    }'
  ```

  ```typescript TypeScript wrap theme={"system"}
  const response = await blnk.Transactions.create({
    precise_amount: 35890,
    precision: 100,
    reference: 'unique_reference_1',
    description: 'Backdated transaction',
    currency: 'NGN',
    source: '@source_account',
    destination: '@destination_account',
    effective_date: '2025-02-15T10:30:00Z',
  });
  ```

  ```go Go wrap theme={"system"}
  effectiveDate, _ := time.Parse(time.RFC3339, "2025-02-15T10:30:00Z")
  transaction, resp, err := client.Transaction.Create(blnkgo.CreateTransactionRequest{
    ParentTransaction: blnkgo.ParentTransaction{
      PreciseAmount: 35890,
      Reference:     "unique_reference_1",
      Description:   "Backdated transaction",
      Currency:      "NGN",
      Precision:     100,
      Source:        "@source_account",
      Destination:   "@destination_account",
      EffectiveDate: &effectiveDate,
    },
  })
  ```
</CodeGroup>

<Tip>
  Use the `effective_date` field (optional, string) to specify the date a transaction financially occurred, formatted in ISO 8601 (e.g., "2023-01-15T10:30:00Z"). If left blank, `effective_date` defaults to the same value as `created_at`.
</Tip>

```json Response theme={"system"}
{
  "transaction_id": "txn_c62f200b-905f-4983-a349-cadd279234aa",
  "status": "applied",
  "amount": 358.90,
  "reference": "unique_reference_1",
  "source": "bln_a03ef6af-1e5d-46a8-86a9-5fb1f2286f66",
  "destination": "bln_68be0aed-383c-4d27-87db-fb0650093686",
  "effective_date": "2025-02-15T10:30:00Z",
  "created_at": "2025-03-02T15:30:45Z"
}
```

***

## Balance calculations

In this section, you'll learn how this affects how balances calculated.

### Current running balance

* Backdated transactions immediately update the current running balance.
* The running balance always reflects the most up-to-date financial position based on all known transactions.

### Example

* Current balance before backdated transaction: `$500`.
* Record a `$200` transaction with an `effective_date` from last month.
* Current balance after: `$700`.

***

## Historical balance queries

When querying a balance at a specific point in time, the system:

1. Starts with the most recent snapshot before the requested time
2. Applies all transactions with an `effective_date` on or before the requested time
3. Ignores transactions with an `effective_date` after the requested time

```json Response example theme={"system"}
{
  "balance_id": "bln_a03ef6af-1e5d-46a8-86a9-5fb1f2286f66",
  "balance": "1245.67",
  "credit_balance": "2000.00",
  "debit_balance": "754.33",
  "currency": "NGN",
  "timestamp": "2025-03-01T13:19:26Z"
}
```

In this example historical balance calculation includes:

* All transactions with `effective_date` on or before March 1st, 2025.
* Transactions recorded after March 1st are included if their effective date is on or before that date.

<Card title="Historical balances" icon="clock" href="/balances/historical-balances">
  Balances at past points in time.
</Card>

***

## Common use cases

Here are some use cases for backdating transactions:

1. **Late-arriving transactions:** Record transactions that occurred in the past but were discovered later, ensuring historical accuracy with backdated entries.
2. **Month-end reconciliation:** Attribute transactions to the correct fiscal period by backdating them, maintaining accurate financial records for period-end reporting.
3. **Financial reporting:** Generate precise reports for specific time periods by backdating transactions to reflect their true financial occurrence, improving data integrity.
4. **Audit compliance:** Maintain historically accurate records for auditing purposes by backdating transactions, ensuring compliance with regulatory requirements.
5. **Error correction:** Rectify mistakes or omissions in past records by backdating transactions to their original dates, preserving ledger accuracy. See also: [Adjusting Balances →](/guides/adjusting-balances).
6. **Historical analysis:** Support retrospective financial analysis or trend tracking by backdating transactions, enabling accurate insights into past performance.

***

## Best practices & constraints

### Important Considerations

* Backdated transactions immediately impact the running balance.
* The `effective_date`:
  * Can be in the past.
  * Must not be in the future. Use `scheduled_for` instead to schedule transactions in the future. Learn how: [Scheduling Transactions →](/transactions/scheduling).
  * Defaults to the same value as `created_at` if not specified.

### Error Handling

Invalid effective date error:

```json theme={"system"}
{
  "error": "Invalid effective_date: must not be in the future",
  "status": 400
}
```

***

## Need help?

We are very happy to help you make the most of Blnk, regardless of whether it is your first time or you are switching from another tool.

To ask questions or discuss issues, please [contact us](mailto:support@blnkfinance.com) or [join our Discord community](https://discord.gg/7WNv94zPpx).

<CtaCallout title="Connect your ledger to Blnk Cloud" href="https://cloud.blnkfinance.com/auth/sign-up?utm_source=blnk_docs&utm_medium=documentation&utm_campaign=need-help" buttonLabel="Open Blnk Cloud" trackingEvent="clicked_cloud_signup">
  Sign up and manage your ledger with our back-office dashboard. You can invite teammates to collaborate and manage your ledger operations directly from the dashboard.
</CtaCallout>
